--- old/usr/src/uts/common/inet/ip/ipclassifier.c	2016-07-13 01:32:38.063480935 -0400
+++ new/usr/src/uts/common/inet/ip/ipclassifier.c	2016-07-13 01:32:38.072560370 -0400
@@ -2722,3 +2722,35 @@
 	return (1);
 }
 #endif
+
+mblk_t *
+conn_get_pid_mblk(conn_t *connp)
+{
+	mblk_t *mblk;
+	conn_pid_info_t *cpi;
+
+	/*
+	 * If the connection is closing, it is not safe to make an upcall or
+	 * access the stream associated with the connection.
+	 */
+	if (!(connp->conn_state_flags & CONN_CLOSING)) {
+		if (connp->conn_upper_handle != NULL) {
+			return (*connp->conn_upcalls->su_get_sock_pid_mblk)
+			    (connp->conn_upper_handle);
+		} else if (!IPCL_IS_NONSTR(connp) && connp->conn_rq != NULL &&
+		    connp->conn_rq->q_stream != NULL) {
+			return (sh_get_pid_mblk(connp->conn_rq->q_stream));
+		}
+	}
+
+	/* return an empty mblk */
+	if ((mblk = allocb(sizeof (conn_pid_info_t), BPRI_HI)) == NULL)
+		return (NULL);
+	mblk->b_wptr += sizeof (conn_pid_info_t);
+	cpi = (conn_pid_info_t *)mblk->b_datap->db_base;
+	cpi->cpi_contents = CONN_PID_INFO_NON;
+	cpi->cpi_pids_cnt = 0;
+	cpi->cpi_tot_size = sizeof (conn_pid_info_t);
+	cpi->cpi_pids[0] = 0;
+	return (mblk);
+}
